﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;

namespace ServiceSecurity
{
    internal class KeyChecker
    {
#if DEBUG
        private const string PedamaUrl = "https://localhost:57588";
#else
        private const string PedamaUrl = "https://pedama.dev.owl-live.de";
#endif

        public KeyChecker(){}

        private HttpClient InitaliteHttpClient(string key)
        {
            var httpClient = new HttpClient();
            
            httpClient.BaseAddress = new Uri($"{PedamaUrl}/ServiceSecurity/ValidateApiKey");
            httpClient.DefaultRequestHeaders.Add("Accept", "application/json");
            httpClient.DefaultRequestHeaders.Add("User-Agent", "OWL-Service-Security-Handler");
            httpClient.DefaultRequestHeaders.Add("x-owl-api-key", key);

            return httpClient;
        }

        public async Task<bool> IsKeyValid(string apikey, string service)
        {
            var arguments = $"?service={service}";

            var _httpClient = InitaliteHttpClient(apikey);
            var response = await _httpClient.PostAsync(arguments, null);

            if (response.IsSuccessStatusCode) return true;

            return false;
        }

        public async Task<bool> IsKeyValid(string apikey, string service, string endpoint)
        {
            var arguments = $"?service={service}&endpoint={endpoint}";
            
            var _httpClient = InitaliteHttpClient(apikey);
            var response = await _httpClient.PostAsync(arguments, null);

            if (response.IsSuccessStatusCode) return true;

            return false;
        }
    }
}
